#ifndef _FCNS_H_
#define _FCNS_H_

#include "vardec.h"
#include "net.h"


/* File: bbs.c */

int checkpw(void);
void end_bbs(int lev);
void sublist(void);
void dirlist(void);
void text_edit(void);
void parse_email_info(char *s, unsigned short *un1, unsigned short *sy1);
void send_email(void);
void mainmenu(void);
void dlmainmenu(void);
int date_changed(void);
void print_local_file(char *ss, char *ss1);
void getcaller(void);
void gotcaller(unsigned int ms, unsigned int cs);
void main(int argc, char *argv[]);


/* File: bbsutl.c */

void far *malloca(unsigned long nbytes);
void stuff_in(char *s, char *s1, char *f1, char *f2, char *f3, char *f4, char *f5);
void copy_line(char *s, char *b, long *ptr, long len);
char *mmkey(int dl);
void inli(char *s, char *rollover, int maxlen, int crend);
int so(void);
int cs(void);
int lcs(void);
void checka(int *abort, int *next);
void pla(char *s, int *abort);
char *ctim(double d);
int sysop2(void);
void reqchat(void);
void yourinfo(void);
void upload_post(void);
int checkcomp(char *s);
int check_ansi(void);
int read_in_file(char *fn, messagerec *m, int maxary);
int set_language_1(int n);
int set_language(int n);


/* File: bbsutl1.c */

int ok_local(void);
int finduser1(char *sx);
void sl1(int cmd,char *s);
void sysopchar(char *s);
void sysoplog(char *s);
void ssm(unsigned int un, unsigned int sy, char *s);
void rsm(int un, userrec *u);
void show_chains(int *mapp, int *map);
void run_chain(int cn);
void do_chains(void);


/* File: com.c */

int check_comport(int pn);
void savel(char *cl, char *atr, char *xl, char *cc);
void restorel(char *cl, char *atr, char *xl, char *cc);
void ptime(void);
void reprint(void);
void print_help(int n);
void setbeep(int i);
void far interrupt async_isr(void);
void outcomch(char ch);
char peek1c(void);
char get1c(void);
int comhit(void);
void dump(void);
void set_baud(unsigned int rate);
void initport(int port_num);
void closeport(void);
void dtr(int i);
void rts(int i);
int cdet(void);
void checkhangup(void);
void addto(char *s, int i);
void makeansi(unsigned char attr, char *s, int forceit);
void setfgc(int i);
void setbgc(int i);
void execute_ansi(void);
void outchr(char c);
void outstr(char *s);
void nl(void);
void nln(int n);
void backspace(void);
void setc(unsigned char ch);
void pausescr(void);
void npr(char *fmt, ...);
void pl(char *s);
void pln(int n);
int kbhitb(void);
int empty(void);
void skey1(char *ch);
char getchd(void);
char getchd1(void);
char inkey(void);
void mpl(int i);
char upcase(char ch);
unsigned char getkey(void);
void input1(char *s, int maxlen, int lc, int crend);
void input(char *s, int len);
void inputl(char *s, int len);
int yn(void);
int ny(void);
char ynq(void);
void ansic(int n);
char onek(char *s);
void prt(int i, char *s);
void reset_colors(void);
void goxy(int x, int y);


/* File: conio.c */

void my_video_int(void);
void set_global_handle(int i);
void global_char(char ch);
void set_x_only(int tf, char *fn, int ovwr);
void movecsr(int x,int y);
int wherex(void);
int wherey(void);
void lf(void);
void cr(void);
void clrscrb(void);
void bs(void);
void out1chx(unsigned char ch);
void out1ch(unsigned char ch);
void outs(char *s);
void pr_wait(int i1);
void set_protect(int l);
void savescreen(screentype *s);
void restorescreen(screentype far *s);
void makewindow(int x, int y, int xlen, int ylen);
void editline(char *s, int len, int status, int *returncode, char *ss);
void val_cur_user(void);
void temp_cmd(char *s, int ccc);
char scan_to_char(unsigned char ch);
void alt_key(unsigned char ch);
void skey(char ch);
void tleft(int x);
void topscreen(void);
void two_way_chat(char *s, char *rollover, int maxlen, int crend);
void chat1(char *chatline, int two_way);
void set_autoval(int n);


/* File: connect1.c */

void zap_call_out_list(void);
void read_call_out_list(void);
void zap_bbs_list(void);
void read_bbs_list(void);
void read_bbs_list_index(void);
int system_index(unsigned int ts);
int valid_system(unsigned int ts);
net_system_list_rec *next_system(unsigned int ts);
void zap_contacts(void);
void read_contacts(void);
void set_net_num(int n);


/* File: extrn.c */

unsigned char getkeyext(void);
void cd_to(char *s);
void get_dir(char *s, int be);
void initporte(int port_num);
int do_it(char *cl);
int do_remote(char *s, int ccc);
void checka1(void);
void checka2(void);
int run_external(char *s);
int run_external_ul(char *s);
int run_external1(char *s);
void outdosstr(char *s);
int do_external(char *s, int enab);
int full_external(char *s, int ctc, int ccc);
char *create_chain_file(char *fn);


/* File: modem.c */

void pr1(unsigned char *s);
void get_modem_line(char *s, double d, int allowa);
void do_result(result_info *ri);
void process_full_result(char *s);
int mode_switch(double d, int allowa);
void holdphone(int d);
void imodem(int x);
void answer_phone(void);


/* File: msgbase.c */

void describe_area_code(int areacode, char *description);
void setorigin(int sysnum, int usernum);
int okfsed(void);
void remove_link(messagerec *m1, char *aux);
int open_file(char *fn);
void set_gat_section(int f, int section);
void save_gat(int f);
void savefile(char *b, long l1, messagerec *m1, char *aux);
char *readfile(messagerec *m1, char *aux, long *l);
void change_storage(messagerec *oldm, char *olda, messagerec *newm, char *newa);
void load_workspace(char *fnx, int no_edit);
void osan(char *s, int *abort, int *next);
void addline(char *b, char *s, long *ll);
void stuff(char *s, char *old, char *new);
void inmsg(messagerec *m1, char *title, int *anony, int needtitle, char *aux, int fsed, char *dest, int flags);
int forwardm(unsigned short *u, unsigned short *s);
void sendout_email(char *title, messagerec *msg, int anony, unsigned un, unsigned sy, int an, unsigned uf, unsigned sf, int fwd, int fnn);
int ok_to_mail(unsigned un, unsigned sy, int forceit);
void email(unsigned short un, unsigned short sy, int forceit, int anony);
void imail(unsigned short u, unsigned short s);
void iscan(int b);
void iscan_hash(int b);
void savebase(void);
void plan(char *s, int *abort, int *next);
void read_message1(messagerec *m1, char an, int readit, int *next, char *fn);
int printfile(char *fn);
void read_message(int n, int *next, int *val);
void lineadd(messagerec *m1, char *sx, char *aux);
void delete(int mn);


/* File: msgbase1.c */

void send_net_post(postrec *p, char *extra, int subnum);
void post(void);
void extract_out(char *b, long len, char *title);
void grab_user_name(messagerec *m, char *fn);
void scan(int msgnum, int optype, int *nextsub);
void qscan(int bn, int *ns);
void nscan(int ss);
void scan2(void);
void printmenu(int i);
void delmail(int f, int loc);
void purgemail(int f,int *mloc,int mw,int *curmail, mailrec *m1, slrec *ss);
void readmail(void);
void remove_post(void);
int external_edit(char *fn1, char *direc, int ednum, int numlines, char *dest, char *title, int flags);
void grab_quotes(messagerec *m, char *aux);


/* File: shrink.c */

int restore_data(char *s);
void save_state(char *s, int state,int ctc);
char *findit(char *cmd,char *ext);
void do_it_1(char *cl);
void shrink_out(char *command, int state, int intercept,int ctc,int ccc);


/* File: sr.c */

char *stripfn(char *fn);
void stripfn1(char *fn);
void calc_CRC(unsigned char b);
char gettimeout(double d, int *abort);
int extern_prot(int pn, char *fn1, int sending);
int ok_prot(int pn, xfertype xt);
char *prot_name(int pn);
int get_protocol(xfertype xt);
void ascii_send(char *fn, int *sent, double *percent);
void maybe_internal(char *fn, int *xferred, double *percent, char ft, char *ftp, int send, int prot);
void send_file(char *fn, int *sent, int *abort, char ft, char *sfn, int dn, long fs);
void receive_file(char *fn, int *received, char *ft, char *sfn, int dn);
char end_batch1(void);
void endbatch(void);


/* File: utility.c */

void reset_act_sl(void);
void remove_from_temp(char *fn, char *dir, int po);
void check_event(void);
void run_event(void);
double freek(int dr);
unsigned char years_old(unsigned char m, unsigned char d, unsigned char y);
void itimer(void);
double timer(void);
long timer1(void);
int sysop1(void);
int okansi(void);
void frequent_init(void);
void fix_user_rec(userrec *u);
void close_user(void);
void open_user(void);
int number_userrecs(void);
void read_user(unsigned int un, userrec *u);
void write_user(unsigned int un, userrec *u);
int open_qscn(void);
void close_qscn(void);
void read_qscn(unsigned int un, unsigned long *qscn, int stayopen);
void write_qscn(unsigned int un, unsigned long *qscn, int stayopen);
void save_status(void);
double ratio(void);
double post_ratio(void);
char *nam(userrec *u1, unsigned int un);
char *nam1(userrec *u1, unsigned int un, unsigned int sy);
double nsl(void);
char *date(void);
char *times(void);
unsigned int finduser(char *s);
void changedsl(void);
void isr(int un, char *name);
void dsr(char *name);
void wait(double d);
void wait1(long l);
double freek1(char *s);
int exist(char *s);
void add_ass(int i, char *ss);
int find_interrupt(void);
void send_net(net_header_rec *nh, unsigned int *list, char *text, char *byname);
unsigned char dow(void);
void detect_multitask(void);
void giveup_timeslice(void);
void begin_crit(void);
void end_crit(void);


/* File: xfer.c */

int check_batch_queue(char *fn);
int check_ul_event(int dn, uploadsrec *u);
void finddevs(char (*devs)[9], int *count);
void find_devices(void);
int okfn(char *s);
void print_devices(void);
char *make_abs_cmd(char *out);
void get_arc_cmd(char *out, char *arcfn, int cmd, char *ofn);
int list_arc_out(char *fn, char *dir);
int ratio_ok(void);
int dcs(void);
void dliscan1(int dn);
void dliscan_hash(int dn);
void dliscan(void);
void closedl(void);
void add_extended_description(char *fn, char *desc);
void delete_extended_description(char *fn);
char *read_extended_description(char *fn);
void print_extended(char *fn, int *abort, unsigned char numlist, int indent);
void modify_extended_description(char **sss, char *dest, char *title);
void align(char *s);
int compare(char *s1, char *s2);
void printinfo(uploadsrec *u, int *abort);
void printtitle(int *abort);
void file_mask(char *s);
void listfiles(void);
void nscandir(int d, int *abort,int title);
void nscanall(void);
void searchall(void);
int recno(char *s);
int nrecno(char *s,int i1);
int printfileinfo(uploadsrec *u, int dn);
void upload(int dn);
long date_to_daten(char *datet);
int try_to_download(char *s, int dn,int title);
void download(void);
void setldate(void);
void finddescription(void);
void arc_l(void);
void yourinfodl(void);
void l_config_nscan(void);
void config_nscan(void);
void xfer_defaults(void);
void removefile(void);


/* File: strings.c */

int set_strings_fn(int filen, char *dir, char *fn, int allowwrite);
void put_string(int filen, int n, char *s);
int cachestat(void);
char *get_stringx(int filen, int n);
char *get_string(int n);
int num_strings(int filen);
char *getrandomstring(int filen);
void close_strfiles(void);


/* File: batch.c */

void listbatch(void);
void delbatch(int i);
void downloaded(char *fn, long cps);
void didnt_upload(int ind);
int try_to_ul(char *fn);
void uploaded(char *fn, long cps);
void ymbatchdl(int had);
void handle_dszline(char *l);
double ratio1(long a);
void make_ul_batch_list(char *listfn);
void make_dl_batch_list(char *listfn);
void run_cmd(char *cmdln, char *downlist, char *uplist, char *dl, int had);
void process_dszlog(void);
void dszbatchdl(int had, char *cmdln, char *desc);
void dszbatchul(int had, char *cmdln, char *desc);
void bibatch(int had, char *cmdln, char *desc);
void batchdl(void);


/* File: chnedit.c */

void chaindata(int n, char *s);
void showchains(void);
void modify_chain(int n);
void insert_chain(int n);
void delete_chain(int n);
void chainedit(void);


/* File: defaults.c */

void select_editor(void);
void print_cur_stat(void);
char *cn(char c);
char *describe(char col);
void color_list(void);
void change_colors(void);
void l_config_qscan(void);
void config_qscan(void);
void list_macro(unsigned char *s);
void make_macros(void);
void input_pw1(void);
void modify_mailbox(void);
void optional_lines(void);
void enter_regnum(void);
void defaults(void);


/* File: diredit.c */

void dirdata(int n, char *s);
void showdirs(void);
void modify_dir(int n);
void insert_dir(int n);
void delete_dir(int n);
void dlboardedit(void);


/* File: gfiles.c */

char *get_file(char *fn, long *len);
gfilerec *read_sec(int sn, int *nf);
void list_sec(int *map, int nmap);
void list_gfiles(gfilerec *g, int nf);
void gfile_sec(int sn);
void gfiles(void);


/* File: gfledit.c */

void gfiledata(int n, char *s);
void showsec(void);
int exist_dir(char *s);
void modify_sec(int n);
void insert_sec(int n);
void delete_sec(int n);
void gfileedit(void);
int fill_sec(int sn);


/* File: lilo.c */

void getuser(void);
void logon(void);
void logoff(void);


/* File: misccmd.c */

void read_automessage(void);
void write_automessage1(void);
void write_automessage(void);
void bbslist(void);
void kill_old_email(void);
void list_users(void);
void print_quest(int f, int mapp, int map[21]);
int print_question(int f, int i, int ii);
void vote_question(int f, int i, int ii);
void vote(void);


/* File: multmail.c */

void multimail(int *un, int numu);
int oneuser(void);
void add_list(int *un, int *numu, int maxu, int allowdup);
void slash_e(void);


/* File: netsup.c */

int run_external1_x(char *cl);
void shrink_out_x(char *cl);
void checkup(struct ftime *f1, struct ftime *f2, int *tf);
int checkup2(struct ftime *f, char *x);
int check_bbsdata(void);
void cleanup_net(void);
void do_callout(int sn);
int ok_to_call(int i);
void fixup_long(long *f, long l);
void attempt_callout(void);
void force_callout(void);
void print_pending_list(void);
void gate_msg(net_header_rec *nh, char *text, unsigned short nn, char *byname, unsigned int *list, unsigned short fnn);


/* File: newuser.c */

int check_name(char *nn);
void input_name(void);
void input_realname(void);
void input_callsign(void);
int valid_phone(char *phone);
void input_phone(void);
void input_street(void);
void input_city(void);
void input_state(void);
void input_country(void);
void input_zipcode(void);
void input_dataphone(void);
void input_sex(void);
void input_age(userrec *u);
void input_comptype(void);
void input_screensize(void);
void input_pw(void);
void input_ansistat(void);
void newuser(void);


/* File: srrcv.c */

char modemkey(int *tout);
int receive_block(char *b, unsigned char *bln, int ucrc);
void xymodem_receive(char *fn, char *ft, int *received, int ucrc);


/* File: srsend.c */

void send_block(char *b, int type, int ucrc, char bn);
char send_b(int f, long pos, int type, char bn, int *ucrc, char *fn, int *terr, int *abort);
int okstart(int *ucrc, int *abort);
void xymodem_send(char *fn, int *sent, double *percent, char ft, int ucrc, int ym, int ymb);


/* File: subedit.c */

void save_subs(void);
void boarddata(int n, char *s);
void showsubs(void);
void modify_sub(int n);
void insert_sub(int n);
void delete_sub(int n);
void boardedit(void);


/* File: subreq.c */

void sub_req(int main_type, int minor_type, int tosys, char *extra);
int find_hostfor(char *type, unsigned short *ui, char *desc, unsigned short *opt);
void sub_xtr_del(int n, int nn, int f);
void sub_xtr_add(int n, int nn);


/* File: sysopf.c */

void isr1(int un, char *name);
void reset_files(void);
void get_status(void);
void prstatus(void);
void valuser(int un);
void print_net_listing(unsigned int ss);
void read_new_stuff(void);
void mailr(void);
void chuser(void);
void zlog(void);
void beginday(void);


/* File: tedit.c */

struct line *read_file(char *fn, int *numlines);
void kill_file(struct line *topline);
void save_file(char *fn, struct line *topline);
int printl(int n, struct line *l);
void tedit(char *fn);


/* File: uedit.c */

void deluser(int un);
void print_data(int un, userrec *u, int lng, int cls);
int matchuser(int un);
int match_user(userrec *u);
void changeopt(void);
void uedit(int usern, int other);


/* File: voteedit.c */

void print_quests(int f);
void set_question(int f, int ii);
void ivotes(void);
void voteprint(void);


/* File: xferovl.c */

void move_file(void);
int comparedl(uploadsrec *x, uploadsrec *y, int type);
void quicksort(int l,int r,int type);
void sortdir(int dn, int type);
void sort_all(int type);
void rename_file(void);
int upload_file(char *fn, int dn, char *desc);
int maybe_upload(char *fn, int dn, char *desc);
void upload_files(char *fn, int dn, int type);
int uploadall(int dn);


/* File: xfertmp.c */

long bad_filename(char *fn);
int check_for_files_arc(char *fn);
int check_for_files_zip(char *fn);
int check_for_files_lzh(char *fn);
int check_for_files_arj(char *fn);
int check_for_files(char *fn);
void download_temp_arc(char *fn, int xfer);
void add_arc(char *arc, char *fn, int dos);
void add_temp_arc(void);
void del_temp(void);
void list_temp_dir(void);
void temp_extract(void);
void list_temp_text(void);
void list_temp_arc(void);
void temporary_stuff(void);


/* File: xinit.c */

void far *mallocx(unsigned long l, char *where);
void init(void);


/* File: subxtr.c */

int read_subs_xtr(int max_subs, int num_subs, subboardrec *subboards);

#endif
